local Sponge_Defaults = {
			a_UpdateInterval	=	0.1
	}
	
local SpongeSpells = {
		--Death Knight
			--48707,		-- Anti-Magic Shell
		77535,		-- Blood Shield (Mastery, Blood)
		--Demon Hunter
		--Druid
		--Hunter
		--Mage
		11426,		-- Ice Barrier (Talent)
		--Monk
		115295,		-- Guard (Brewmaster)
		116849,		-- Life Cocoon (Mistweaver)
		--Paladin
		65148,		-- Sacred Shield (Talent)
		157047,		-- Saved by the Light (Talent, Holy)
		86273,		-- Illuminated Healing (Mastery, Holy)
		--Priest
		17,			-- PowerWord:Shield
		123258,		-- PowerWord:Shield (Discipline)
		47753,		-- Divine Aegis (Discipline)
		114908,		-- Spirit Shell (Discipline)
		--Rogue
		--Shaman
		114893,		-- Stone Bulwark (Talent)
		--Warlock
		108366,		-- Soul Leech (Talent)
		108416,		-- Sacrificial Pact (Talent)
		--Warrior
		112048,		-- Shield Barrier (Protection)
	}

function Absorbent_OnLoad(Frame)
	Frame:RegisterForDrag("LeftButton")
	Frame:RegisterEvent("PLAYER_LOGIN")

	--Priest Bubbles
	ps_pws		 = GetSpellInfo(17)			-- PowerWord:Shield
	ps_pws_disc	 = GetSpellInfo(123258)		-- PowerWord:Shield (Discipline)
	ps_daeg		 = GetSpellInfo(47753)		-- Divine Aegis
	ps_sshell	 = GetSpellInfo(114908)		-- Spirit Shell
	--ps_ws		 = GetSpellInfo(6788)		-- Weakened Soul
	
	--Mage Bubbles
	mg_ice = GetSpellInfo(11426)			-- Ice Barrier
	
	--Deathknight Bubbles
	dk_ams = GetSpellInfo(48707)			-- Anti-Magic Shell
	

-------------------------------
--Default values
	if (spongeDB == nil) then 
		spongeDB = Sponge_Defaults
	end
end

function inTable(tbl, item)
    for key, value in pairs(tbl) do
        if value == item then return key end
    end
    return false
end

function inTableVal(tbl, item)
    for key, value in pairs(tbl) do
        if value == item then return key end
    end
    return false
end

function Absorbent_OnEvent(self, event, ...)
	if (event == "PLAYER_LOGIN") then
		ChatFrame1:AddMessage("|cff00ffffAbsorbent ready to absorb!|r")	
	end
end

function Absorbent_OnUpdate(self, elapsed)
	self.TimeSinceLastUpdate = (self.TimeSinceLastUpdate or 0) + elapsed;
	if (self.TimeSinceLastUpdate > Sponge_Defaults.a_UpdateInterval) then
		BubbleUpdate("player")
		self.TimeSinceLastUpdate = 0
	end
if(UnitExists("target")) then
	_G["SpongeFrameTarget"]:Show()
else
	_G["SpongeFrameTarget"]:Hide()
end
end


function AbsorbentTarget_OnUpdate(self, elapsed)
if(UnitExists("target")) then
	self.TimeSinceLastUpdate = (self.TimeSinceLastUpdate or 0) + elapsed;
	if (self.TimeSinceLastUpdate > Sponge_Defaults.a_UpdateInterval) then
		BubbleUpdate("target")
		self.TimeSinceLastUpdate = 0
	end
end
end


function BubbleUpdate(tgt)
	--local tgt = "target"
	local x,y,z = 0,0,0
	for i = 1,40 do
		local a3,b3,c3,d3,e3,f3,g3,h3,i3,j3,k3 = UnitAura(tgt, i)
		--if (k3 == 17) then -- power word shield part
		if (inTableVal(SpongeSpells,k3)) then
			SpongeTooltip:ClearLines()
			SpongeTooltip:SetUnitBuff(tgt, i)
			local pwstext = SpongeTooltipTextLeft2:GetText()
			local _, pwsamount, _, sacredamount, _ = strsplit(" ", pwstext)
			--if (k3 == 65148) then
			if(sacredamount) then
				pwsamount = sacredamount
			end
			z = z+pwsamount
			--_G[unit.."PWSValue"]:SetText(DiscShieldsHelperFormatText(tonumber(pwsamount)))
		end
	end
		x = UnitHealth(tgt) + z
		y = (z/UnitHealthMax(tgt))*100
			_G[tgt.."SpongeTotal"]:SetText(tonumber(z))
			_G[tgt.."SpongeEHP"]:SetText(tonumber(x))
			_G[tgt.."SpongeEHPPer"]:SetText(tonumber(string.format("%.2f", y)).."%")
end



